# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

# We don't really need ExtUtils::MakeMaker ≥ 6.30
%global old_eumm %(perl -MExtUtils::MakeMaker -e 'print (($ExtUtils::MakeMaker::VERSION < 6.30) ? 1 : 0);' 2>/dev/null || echo 0)

# We need to patch the test suite if we have an old version of Test::More
%global old_test_more %(perl -MTest::More -e 'print (($Test::More::VERSION < 0.88) ? 1 : 0);' 2>/dev/null || echo 0)

# TODO: BR: perl(Test::Pod::LinkCheck) when available
# TODO: BR: perl(Test::Pod::No404s) when available

Name:		perl-Devel-StackTrace
Summary:	Perl module implementing stack trace and stack trace frame objects
Version:	1.31
Epoch:		1
Release:	1.%{__distinit}%{__distvers}
License:	Artistic 2.0
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Devel-StackTrace
Source:		http://search.cpan.org/CPAN/authors/id/D/DR/DROLSKY/Devel-StackTrace-%{version}.tar.gz
Patch1:		Devel-StackTrace-1.29-old-EU::MM.patch
Patch2:		Devel-StackTrace-1.30-old-Test::More.patch
BuildArch:	noarch
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -un)
BuildRequires:	perl(base)
BuildRequires:	perl(Encode)
BuildRequires:	perl(ExtUtils::MakeMaker)
BuildRequires:	perl(File::Find)
BuildRequires:	perl(File::Spec)
BuildRequires:	perl(File::Temp)
BuildRequires:	perl(overload)
BuildRequires:	perl(Scalar::Util)
BuildRequires:	perl(Test)
# We don't run author or release tests when bootstrapping
# Some examples why not:
# Exception::Class -> Devel::StackTrace
# Test::EOL -> Pod::Coverage::TrustPod -> Pod::Eventual -> Test::Deep -> Test::NoWarnings -> Devel::StackTrace
# Test::Spelling -> Pod::Spell -> Test::Deep -> Test::NoWarnings -> Devel::StackTrace
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Exception::Class)
BuildRequires:	perl(Pod::Coverage::TrustPod)
BuildRequires:	perl(Pod::Wordlist::hanekomu)
# Test::CPAN::Changes only available if we have Perl 5.10.0 onwards
%if %(perl -e 'print $] >= 5.010000 ? 1 : 0;')
BuildRequires:	perl(Test::CPAN::Changes)
%endif
BuildRequires:	perl(Test::EOL)
BuildRequires:	perl(Test::NoTabs)
BuildRequires:	perl(Test::Pod) >= 1.41
BuildRequires:	perl(Test::Pod::Coverage) >= 1.08
BuildRequires:	perl(Test::Spelling), aspell-en
# Test::Synopsis requires Test::Builder::Module, available from Perl 5.8.8 (FC-5, EL-5)
%if %(perl -e 'print (($] >= 5.008008) ? 1 : 0);')
BuildRequires:	perl(Test::Synopsis)
%endif
%endif
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))

%description
The Devel::StackTrace module contains two classes, Devel::StackTrace
and Devel::StackTraceFrame. The goal of this object is to encapsulate
the information that can found through using the caller() function, as
well as providing a simple interface to this data.

The Devel::StackTrace object contains a set of Devel::StackTraceFrame
objects, one for each level of the stack. The frames contain all the
data available from caller() as of Perl 5.6.0.

%prep
%setup -q -n Devel-StackTrace-%{version}

# Don't really need ExtUtils::MakeMaker ≥ 6.30
%if %{old_eumm}
%patch1
%endif

# Work with Test::More < 0.88
%if %{old_test_more}
%patch2 -p1
%endif

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -exec rm -f {} ';'
%{_fixperms} %{buildroot}

%check
make test %{!?perl_bootstrap:AUTHOR_TESTING=1 RELEASE_TESTING=1}

%clean
rm -rf %{buildroot}

%files
%defattr(-,root,root,-)
%doc README LICENSE Changes
%{perl_vendorlib}/Devel/
%{_mandir}/man3/Devel::StackTrace.3pm*
%{_mandir}/man3/Devel::StackTrace::Frame.3pm*

%changelog
* Fri Jan 17 2014 Paul Howarth <paul@city-fan.org> - 1:1.31-1
- Update to 1.31
  - Documentation updates, including documenting the as_string() method in
    Devel::StackTrace::Frame (CPAN RT#91575)
- Drop spelling patch, no longer needed

* Thu Jul 18 2013 Paul Howarth <paul@city-fan.org> - 1:1.30-3
- Perl 5.18 rebuild

* Tue May 21 2013 Paul Howarth <paul@city-fan.org> - 1:1.30-2
- Don't BR: perl(Test::Spelling) when bootstrapping, and don't run the
  release tests either, since they'd fail without it

* Tue Nov 20 2012 Paul Howarth <paul@city-fan.org> - 1:1.30-1
- Update to 1.30
  - There was an eval that did not first localize $@ and $SIG{__DIE__}; this
    broke Plack::Middleware::StackTrace (and possibly other things)
- Update patch for building with old Test::More versions
- Fix bogus date in spec changelog

* Sat Nov 17 2012 Paul Howarth <paul@city-fan.org> - 1:1.29-1
- Update to 1.29
  - Allow arguments to a trace's as_string method, specifically max_arg_length
  - Added a no_args option to the constructor in 1.26 but forgot to mention it
    in Changes (CPAN RT#71482)
  - The Devel::StackTrace->frames() method is now read-write, which allows you
    to do more complex filtering of frames than is easily possible with the
    frame_filter argument to the constructor
- Update patches
- Drop BR: perl(Test::Kwalitee); kwalitee test dropped upstream
- BR: perl(Test::CPAN::Changes)

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1:1.27-8
- Perl 5.16 post-bootstrap rebuild

* Sun Jul  1 2012 Paul Howarth <paul@city-fan.org> - 1:1.27-7
- BR: perl(base), perl(Encode), perl(File::Spec) and perl(Test)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - perl(Exception::Class) available for all supported releases now
  - Never need to BR: aspell-en-gb
  - Use DESTDIR rather than PERL_INSTALL_ROOT

* Tue Feb  7 2012 Paul Howarth <paul@city-fan.org> - 1:1.27-6
- Don't BR: perl(Exception::Class), perl(Test::EOL) or perl(Test::Kwalitee) if
  we're bootstrapping

* Fri Jun 24 2011 Paul Howarth <paul@city-fan.org> - 1:1.27-5
- Rebuild for perl 5.14.1 in Rawhide
- Fix dist tag for CentOS 6 and Scientific Linux

* Tue Apr 26 2011 Paul Howarth <paul@city-fan.org> - 1:1.27-4
- Test::Spelling now available for all releases

* Wed Mar 23 2011 Paul Howarth <paul@city-fan.org> - 1:1.27-3
- BR: perl(Test::Kwalitee) unconditionally

* Tue Mar 22 2011 Paul Howarth <paul@city-fan.org> - 1:1.27-2
- BR: perl(Test::Kwalitee)
- Nobody else likes macros for commands
- Use %%{_fixperms} instead of our own chmod incantation

* Sun Jan 16 2011 Paul Howarth <paul@city-fan.org> - 1:1.27-1
- Update to 1.27 (skip some tests on 5.13.8+ that are no longer relevant
  because of a change in the Perl core - CPAN RT #64828)
- Update patch for old Test::More versions

* Fri Oct 15 2010 Paul Howarth <paul@city-fan.org> - 1:1.26-1
- Update to 1.26 (the as_string method did not localize $@ and $SIG{__DIE__}
  before doing an eval - CPAN RT#61072)
- Update patch for old Test::More versions

* Tue Sep  7 2010 Paul Howarth <paul@city-fan.org> - 1:1.25-1
- Update to 1.25 (Devel::StackTraceFrame was not actually subclassing
  Devel::StackTrace::Frame)
- Update patch for old Test::More versions

* Sun Sep  5 2010 Paul Howarth <paul@city-fan.org> - 1:1.24-1
- Update to 1.24:
  - Version 1.23 was missing a $VERSION assignment
  - Moved the frame object to its own file, and renamed it
    Devel::StackTrace::Frame; the old package name, Devel::StackTraceFrame, is
    now a subclass of the new package, to provide a backwards compatibility shim
- Package manpage for Devel::StackTrace::Frame
- BuildRequires: perl(Exception::Class) for additional test coverage

* Sun Aug 29 2010 Paul Howarth <paul@city-fan.org> - 1:1.23-1
- Update to 1.23:
  - License changed to Artistic 2.0
  - Added message and indent constructor parameters (CPAN RT#59830)
- Use RELEASE_TESTING rather than IS_MAINTAINER for author tests
- BuildRequires: perl(Test::EOL)
- BuildRequires: perl(Test::NoTabs)
- BuildRequires: perl(Test::Spelling), aspell-en if available
- Add patch to cope with absence of Test::Spelling in test suite
- Add patch to cope with Test::More < 0.88

* Fri Jun 25 2010 Paul Howarth <paul@city-fan.org> - 1:1.22-5
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> - 1:1.22-4
- Fix dist tag for RHEL-6 Beta

* Wed Nov 25 2009 Paul Howarth <paul@city-fan.org> - 1:1.22-3
- Import from Fedora

* Sat Jul 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.22-2
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Mon Jul 20 2009 Ralf Corsépius <corsepiu@fedoraproject.org> - 1:1.22-1
- Upstream update.

* Thu Feb 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1:1.20-3
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Feb 18 2009 Ralf Corsépius <corsepiu@fedoraproject.org> - 1:1.20-2
- BR: perl(Test::Kwalitee)

* Sat Dec 13 2008 Ralf Corsépius <corsepiu@fedoraproject.org> - 1:1.20-1
- Upstream update
- Bump epoch

* Fri Aug 08 2008 Ralf Corsépius <rc040203@freenet.de> - 1.1902-1
- Upstream update

* Wed Jun 25 2008 Ralf Corsépius <rc040203@freenet.de> - 1.1901-1
- Upstream update

* Fri May 16 2008 Ralf Corsépius <rc040203@freenet.de> - 1.18-2
- Bump release

* Mon Apr 07 2008 Ralf Corsépius <rc040203@freenet.de> - 1.18-1
- Upstream update

* Wed Feb 27 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.16-2
- Rebuild for perl 5.10 (again)

* Sun Feb 03 2008 Ralf Corsépius <rc040203@freenet.de> - 1.16-1
- Upstream update
- Activate IS_MAINTAINER-tests
- BR: perl(Test::Pod::Coverage)

* Mon Jan 14 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.15-3
- Rebuild for new perl

* Wed Aug 29 2007 Ralf Corsépius <rc040203@freenet.de> - 1.15-2
- Update License

* Mon Apr 30 2007 Ralf Corsépius <rc040203@freenet.de> - 1.15-1
- Upstream update

* Sat Mar 17 2007 Ralf Corsépius <rc040203@freenet.de> - 1.14-1
- Upstream update

* Tue Sep 05 2006 Ralf Corsépius <rc040203@freenet.de> - 1.13-2
- Mass rebuild

* Tue Apr 04 2006 Ralf Corsépius <rc040203@freenet.de> - 1.13-1
- Upstream update

* Wed Mar 01 2006 Ralf Corsépius <rc040203@freenet.de> - 1.12-2
- Rebuild for perl-5.8.8

* Sun Oct 02 2005 Ralf Corsepius <rc040203@freenet.de> - 1.12-1
- Upstream update
